# Copyright (C) 2006 All right reserved by Shinya Kondo ( CGI KON )

	require "timelocal.pl";
	require "sample.inc" if(-e "sample.inc");

	&Change_Sample if($SAMPLE_ERROR);

# 

	$SOFT_TITLE = qq!ڻͽ!;

	$PAGE_TITLE = qq!ͽ󥫥!;

	$BOOK_TITLE = qq!!;

	$COPY_TITLE = qq!Powered by CGIKON!;

	@LIST_DAYS = (0,31,28,31,30,31,30,31,31,30,31,30,31);

	@LIST_WEEKS = ("","","","","","","");
	@LIST_COLOR = ("#FF0000","#000000","#000000","#000000","#000000","#000000","#0000FF");

	$UNIT_MIN = 5;
	$UNIT_NUM = 12;

# üʸѴ

sub HTML_Chars
{
	my($value) = @_;

	$value =~ s/&/&amp;/g;
	$value =~ s/"/&quot;/g;
	$value =~ s/</&lt;/g;
	$value =~ s/>/&gt;/g;

	return $value;
}

# ץǡѹ

sub Change_Sample
{
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime(time);

	my($yymm) = sprintf("%04d%02d",$year + 1900,$mon + 1);

	my($base_1) = `ls BASE_*.log`;
	my($subs_1) = `ls SUBS_*.log`;

	chomp($base_1);
	chomp($subs_1);

	my($base_2) = "BASE_".$yymm.".log";
	my($subs_2) = "SUBS_".$yymm.".log";

	rename($base_1,$base_2) if($base_1 ne $base_2);
	rename($subs_1,$subs_2) if($subs_1 ne $subs_2);
}

# եǡμ

sub Get_Days
{
	my($yyyy,$mm) = @_;

	my($date) = $yyyy * 12 + $mm;

	$yyyy = int(($date - 1) / 12);
	$mm = ($date - 1) % 12 + 1;

	my($time) = timelocal(0,0,0,1,$mm - 1,$yyyy);
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$yyyy = $year + 1900;
	$mm = $mon + 1;

	if($mm == 2) {
		if($yyyy % 400 == 0) {
			$LIST_DAYS[2] = 29;
		} elsif($yyyy % 100 == 0) {
			$LIST_DAYS[2] = 28;
		} elsif($yyyy % 4 == 0) {
			$LIST_DAYS[2] = 29;
		} else {
			$LIST_DAYS[2] = 28;
		}
	}
	$mday = $LIST_DAYS[$mm];

	return $yyyy,$mm,$mday,$wday;
}

# ̤ꥹȤμ

sub Get_Days_List
{
	my($date) = @_;

	my(@column,%result);

	my(%values) = &Set_Hash_Subs($date);

	if(open(IFILE,"BASE_".$date.".log")) {
		while(<IFILE>) {
			@column = split("\t");
			$result{$column[1]} = 1 if($values{$column[0]} == 1);
		}
		close(IFILE);
	}

	return %result;
}

# ̤ꥹȤμ

sub Get_Data_List
{
	my($key,$val,$count,@column,%values,%result);

	if(opendir(DIR,".")) {
		@column = readdir(DIR);
		closedir(DIR);
	}

	$count = 0;
	foreach (@column) {
		if(/^BASE_([0-9]{4})([0-9]{2})\.log$/) {
			%values = &Set_Hash_Subs($1.$2);
			while(($key,$val) = each(%values)) {
				if($val == 1) {
					$result{$1.$2} = $1."ǯ".int($2)."ʬ";
					$count++;
				}
			}
		}
	}
	$result{'0'} = $count;

	return %result;
}

# ͽܺپμ

sub Set_Hash_Subs
{
	my($date) = @_;

	my(@column,%result);

	if(open(IFILE,"SUBS_".$date.".log")) {
		while(<IFILE>) {
			@column = split("\t");
			$result{$column[0]} = $column[1];
		}
		close(IFILE);
	}

	return %result;
}

# ͽܺپμ

sub Set_Date_Subs
{
	my($date) = @_;

	my(@column,%result);

	if(open(IFILE,"SUBS_".$date.".log")) {
		while(<IFILE>) {
			chomp();
			@column = split("\t");
			$result{$column[0]}{'STATUS'} = $column[1];
			$result{$column[0]}{$column[1]} = $column[2];
		}
		close(IFILE);
	}

	return %result;
}

# ͽμ

sub Set_List_Subs
{
	my($date) = @_;

	my(@column,%result);
	my(@status) = ("󥻥","ͽ","ͽ");

	if(open(IFILE,"SUBS_".$date.".log")) {
		while(<IFILE>) {
			chomp();
			@column = split("\t");
			push(@{$result{$column[0]}},$column[2]." ".$status[int($column[1])]);
		}
		close(IFILE);
	}

	return %result;
}

# μ

sub Set_Hash_Note
{
	my($date) = @_;

	my(@column,%result);

	if(open(IFILE,"NOTE_".$date.".log")) {
		while(<IFILE>) {
			chomp();
			@column = split("\t");
			$result{$column[0]} = $column[1];
		}
		close(IFILE);
	}

	return %result;
}

# ͽǽΥå

sub Check_Rest_Days
{
	my($yyyy,$mm,$dd) = @_;

	my($time) = timelocal(0,0,0,$dd,$mm - 1,$yyyy);
	my($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime($time);
	$wday += 1;

	return 1 if($VAL_WDAYS =~ /$wday/);

	my($date) = sprintf("%04d%02d%02d",$yyyy,$mm,$dd);
	my($key1,$key2,$key3);

	foreach (@LIST_REST) {
		next if(!$_);
		$key1 = (/([0-9]+)ǯ/) ? sprintf("%04d",$1) : '[0-9]{4}';
		$key2 = (/([0-9]+)/) ? sprintf("%02d",$1) : '[0-9]{2}';
		$key3 = (/([0-9]+)/) ? sprintf("%02d",$1) : '[0-9]{2}';

		return 2 if($date =~ /$key1$key2$key3/);
	}

	return 0;
}

# ͽǽ֤Υå

sub Check_Rest_Hour
{
	my($yyyy,$mm,$dd,$item,$hh_1,$mm_1,$hh_2,$mm_2) = @_;

	my($time1) = $hh_1 * 60 + $mm_1;
	my($time2) = $hh_2 * 60 + $mm_2;

	my($key1) = $VAL_HOUR1 * 60;
	my($key2) = $VAL_HOUR2 * 60;

	return 1 if($time1 < $key1 || $time2 <= $key1);
	return 2 if($time1 >= $key2 || $time2 > $key2);

	my(%result) = &Set_Hash_Time($yyyy,$mm,$dd);

	foreach (@{$result{$item}}) {
		($status,$hh_1,$mm_1,$hh_2,$mm_2) = @$_;
		next if(!$status);

		$key1 = $hh_1 * 60 + $mm_1;
		$key2 = $hh_2 * 60 + $mm_2;
		return 3 if($time1 < $key2 && $time2 > $key1);
	}

	return 0;
}

# ͽֵڤӾμ

sub Set_Hash_Time
{
	my($yyyy,$mm,$dd) = @_;

	my($item,$hour,$key1,$key2,$hh_1,$mm_1,$hh_2,$mm_2,@column,%result);
	my($yymm) = sprintf("%04d%02d",$yyyy,$mm);
	my(%HASH_SUBS) = &Set_Hash_Subs($yymm);

	if(&Check_Rest_Days($yyyy,$mm,$dd)) {
		for($item = 1;$item <= $#LIST_ITEM;$item++) {
			push(@{$result{$item}},[3,$VAL_HOUR1,0,$VAL_HOUR2,0]);
		}
	}

	foreach $hour (@LIST_HOUR) {
		next if(!$hour);
		($key1,$key2) = split("-",$hour);
		($hh_1,$mm_1) = split(":",$key1);
		($hh_2,$mm_2) = split(":",$key2);
		for($item = 1;$item <= $#LIST_ITEM;$item++) {
			push(@{$result{$item}},[3,$hh_1,$mm_1,$hh_2,$mm_2]);
		}
	}

	if(open(IFILE,"BASE_".$yymm.".log")) {
		while(<IFILE>) {
			($key1,$key2,$item,@column) = split("\t");
			next if($key2 ne $dd);
			($hh_1,$mm_1) = split(":",$column[0]);
			($hh_2,$mm_2) = split(":",$column[1]);
			push(@{$result{$item}},[$HASH_SUBS{$key1},$hh_1,$mm_1,$hh_2,$mm_2]);
		}
		close(IFILE);
	}

	return %result;
}

# ͽμ

sub Get_Record
{
	my($yyyy,$mm,$dd,$item) = @_;

	my($yymm) = sprintf("%04d%02d",$yyyy,$mm);
	my(%HASH_SUBS) = &Set_Date_Subs($yymm);
	my(%HASH_NOTE) = &Set_Hash_Note($yymm);
	my($rec_id,$e_date,$e_item,$time_s,$time_e,$e_name,$e_mail,$e_biko,%result);

	if(open(IFILE,"BASE_".$yymm.".log")) {
		while(<IFILE>) {
			($rec_id,$e_date,$e_item,$time_s,$time_e,$e_name,$e_mail,$e_biko) = split("\t",$_,8);
			next if($e_date ne $dd);
			next if($e_item ne $item);

			$result{$rec_id}{'TIME_S'} = $time_s;
			$result{$rec_id}{'TIME_E'} = $time_e;
			$result{$rec_id}{'E_NAME'} = $e_name;
			$result{$rec_id}{'E_MAIL'} = $e_mail;
			$result{$rec_id}{'E_BIKO'} = $e_biko;
			$result{$rec_id}{'STATUS'} = $HASH_SUBS{$rec_id}{'STATUS'};
			$result{$rec_id}{'DATE_1'} = $HASH_SUBS{$rec_id}{'2'};
			$result{$rec_id}{'DATE_2'} = $HASH_SUBS{$rec_id}{'0'};
			$result{$rec_id}{'E_NOTE'} = $HASH_NOTE{$rec_id} ? 1 : 0;
		}
		close(IFILE);
	}

	return %result;
}

# ͽμ

sub Get_Detail
{
	my($yyyy,$mm,$rec_id) = @_;

	my($yymm) = sprintf("%04d%02d",$yyyy,$mm);
	my(%HASH_NOTE) = &Set_Hash_Note($yymm);
	my(%HASH_SUBS) = &Set_List_Subs($yymm);
	my(@column,%result);

	if(open(IFILE,"BASE_".$yymm.".log")) {
		while(<IFILE>) {
			@column = split("\t");
			next if($column[0] ne $rec_id);

			$result{'E_DATE'} = $column[1];
			$result{'E_ITEM'} = $column[2];
			$result{'TIME_S'} = $column[3];
			$result{'TIME_E'} = $column[4];
			$result{'E_NAME'} = $column[5];
			$result{'E_MAIL'} = $column[6];
			$result{'E_BIKO'} = $column[7];
			$result{'STATUS'} = join("<BR>",@{$HASH_SUBS{$rec_id}});
			$result{'E_NOTE'} = $HASH_NOTE{$rec_id};
		}
		close(IFILE);
	}

	return %result;
}

# 쥳ɤɲ

sub Insert_Record
{
	my($file,@result) = @_;

	if($SAMPLE_ERROR) {
		$sample = $SAMPLE_ERROR;
		return;
	}

	if(open(OFILE,">>$file")) {
		print OFILE join("\t",@result)."\n";
		close(OFILE);
		return;
	} else {
		return "ե˽Ǥޤ";
	}
}

# ͽμ

sub Get_Status
{
	my($yyyy,$mm,$dd) = @_;

	my($hh_1,$hh_2,$mm_1,$mm_2,$key1,$key2,$loop);
	my($item,$hour,$count,$mins,$val,$status,%result);
	my(%HASH_TIME) = &Set_Hash_Time($yyyy,$mm,$dd);

	while(($item,$val) = each(%HASH_TIME)) {
		foreach (@$val) {
			($status,$hh_1,$mm_1,$hh_2,$mm_2) = @$_;
			$key1 = $hh_1 * $UNIT_NUM + int($mm_1 / $UNIT_MIN);
			$key2 = $hh_2 * $UNIT_NUM + int($mm_2 / $UNIT_MIN);
			for($loop = $key1;$loop < $key2;$loop++) {
				$result{$item}[$loop] = $status;
			}
		}
	}

	for($item = 1;$item <= $#LIST_ITEM;$item++) {
		$count = 0;
		for($hour = $VAL_HOUR1;$hour < $VAL_HOUR2;$hour++) {
			$status = $result{$item}[$hour * $UNIT_NUM];
			$HASH_CSPAN{$item}[$count] = 1;
			$HASH_COLOR{$item}[$count] = $status;

			for($mins = 1;$mins < $UNIT_NUM;$mins++) {
				$val = $result{$item}[$hour * $UNIT_NUM + $mins];
				if($val == $status) {
					$HASH_CSPAN{$item}[$count] += 1;
				} else {
					$status = $val;
					$count += 1;
					$HASH_CSPAN{$item}[$count] = 1;
					$HASH_COLOR{$item}[$count] = $status;
				}
			}
			$count += 1;
		}
	}
}

# ɽ

sub Print_Calender
{
	my($flag,$href,$yyyy,$mm) = @_;

	my($mday,$wday,$rest,$day1,$day2,$week,$line,$rows,$cols,$days,$bg_1,$link);
	my(%REST_WEEK,%REST_DAYS,%HASH_DAYS,%result);

	($yyyy,$mm,$mday,$wday) = &Get_Days($yyyy,$mm);
	my($yymm) = sprintf("%04d%02d",$yyyy,$mm);
	%HASH_DAYS = Get_Days_List($yymm) if($flag);

	my(@LIST_DATE) = (0 .. 31);
	if($LINK_DATE =~ /^$yymm([0-9]{2})$/) {
		$days = int($1);
		$LIST_DATE[$days] = "<FONT SIZE=4><B>$days</B></FONT>"
	}
	$LIST_DATE[0] = '';

	foreach $week (split(",",$VAL_WDAYS)) {
		$REST_WEEK{$week - 1} = 3;
	}

	foreach (@LIST_REST) {
		next if(!$_);
		next if(/([0-9]+)ǯ/ && int($1) != $yyyy);
		next if(/([0-9]+)/ && int($1) != $mm);

		$day1 = 1;
		$day2 = 31;
		$day1 = $day2 = int($1) if(/([0-9]+)/);

		for($days = $day1;$days <= $day2;$days++) {
			$REST_DAYS{$days} = 3;
		}
	}

	for($days = 1;$days <= $mday;$days++) {
		$week = ($days + $wday - 1) % 7;
		$line = ($days + $wday - 1) / 7;
		$line = int($line);
		$rest = $REST_WEEK{$week};
		$rest = $REST_DAYS{$days} if($REST_DAYS{$days});
		$rest = $HASH_DAYS{$days} if($HASH_DAYS{$days});

		$result{'DAYS'}[$line][$week] = $days;
		$result{'BG_1'}[$line][$week] = $LIST_BACK[int($rest)];
	}

	print qq!
		<TABLE BORDER=1 CELLPADDING=0 CELLSPACING=1>
		<CAPTION>$yyyyǯ $mm</CAPTION>
		<TR>
	!;

	for($cols = 0;$cols < 7;$cols++) {
		print qq!
			<TD WIDTH=25 HEIGHT=25 ALIGN="center" BGCOLOR="#F5F5F5">
				<FONT COLOR="$LIST_COLOR[$cols]" SIZE=2><B>$LIST_WEEKS[$cols]</B></FONT>
			</TD>
		!;
	}

	print qq!
		</TR>
	!;

	for($rows = 0;$rows <= 5;$rows++) {
		print qq!
		<TR>
		!;
		for($cols = 0;$cols < 7;$cols++) {
			$days = $result{'DAYS'}[$rows][$cols];
			$bg_1 = $result{'BG_1'}[$rows][$cols];
			$link = $href."&yyyy=$yyyy&mm=$mm&dd=$days";
			print qq!
			<TD WIDTH=25 HEIGHT=25 ALIGN="center" VALIGN="bottom" BGCOLOR="$bg_1">
				<A HREF="$link"><FONT COLOR="black" SIZE=2>$LIST_DATE[$days]</FONT></A>
			</TD>
			!;
		}
		print qq!
		</TR>
		!;
	}

	print qq!
		</TABLE>
	!;
}

1;

# Copyright (C) 2006 All right reserved by Shinya Kondo ( CGI KON )
